char IncRxPtrOut(void)
{
  // compute the next valid pointer in the circular queue
  RxPtrOut ++;	// next byte
  if (RxPtrOut>=MAX_RX_BUFF) RxPtrOut=0; //reset circ queue
  return RxPtrOut;
}

void ReadChar(void)
{
  // compute the next valid pointer in the circular queue
  RxPtrIn ++;	// next byte
  if (RxPtrIn>=MAX_RX_BUFF) RxPtrIn=0; //reset circ queue
  
  RxBuff[RxPtrIn] = SpiSerial.read();	
  Serial.print( RxBuff[RxPtrIn], BYTE);
}

void Rx(void)
{	  
  unsigned char RxChar;
  
  RxChar = (RxBuff[IncRxPtrOut()]);
//  Serial.print(RxChar, BYTE);
  
  if(FsmStatus == 0)
  {
    return;  // no data expected, discard received
  }
  
  switch (RxStatus)
  {     
    case 0:  // wait for a given string
            
      if (StrPtr == 0)
      {
        StartPointer = RxPtrOut;  // index of first char of string in queue
      }
      
      if (RxChar == RxString[StrPtr])
      {
        StrPtr++;

        if (StrPtr == strlen(RxString))
        {
          RxStatus = 1; // next status 
          FsmFlag = 1;  // FSM can proceed to next status   
          Error(0);   
          StrPtr=0;
          StopPointer = RxPtrOut;  // index of last char of string in queue
        }
      }
      else
      {
        if(RxChar == RxString[0]) // to resynchronize on first char
        {
          StrPtr = 1;
        }
        else
        {
          StrPtr = 0;
        }
      }

    break;
    
    default:

    break;
  } // switch end
}


